/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
//
//  SampleAppRealmChallengeHandler.m
//  nativepush
//
//  Created by worklightdev on 04/02/13.
//  Copyright (c) 2013 worklightdev. All rights reserved.
//

#import "FormChallengeHandler.h"

@implementation FormChallengeHandler

- (id)initWithController: (ViewController *) mainView{
    if ( self = [super init] )
    {
        vc = mainView;
    }
    return self;
}

- (BOOL)isCustomResponse: (WLResponse *)response {
    if(response == nil || [response responseText] == nil || [[response responseText] rangeOfString:@"j_security_check"].location == NSNotFound){
        return false;
    }
    return true;
}

- (void)handleChallenge: (WLResponse *)response {
	[vc updateMessage:@"\nGoing to log in using FormChallengeHandler"];
	[vc updateMessage:[NSString stringWithFormat:@"\t Username :: %@\n\t Password :: %@", self.username, self.password]];
	
	NSDictionary *params = [NSDictionary dictionaryWithObjectsAndKeys:self.username, @"j_username", self.password, @"j_password", nil];
    NSDictionary *headers = [NSDictionary dictionaryWithObjectsAndKeys:@"aaa", @"custom1", nil];

    [self submitLoginForm:@"j_security_check" requestParameters:params requestHeaders:headers requestTimeoutInMilliSeconds:0 requestMethod:@"post"];
}

-(void)onSuccess:(WLResponse *)response {
    if([self isCustomResponse:response]){
		[self submitFailure:response];
    }
    else {
		[self submitSuccess:response];
    }
	[vc updateMessage:@"Successfully logged in ... "];
	[vc updateMessage:response.description];
}

-(void)onFailure:(WLFailResponse *)response{
    [self submitFailure:response];
	[vc updateMessage:@"Failed to log in ..."];
	[vc updateMessage:response.description];
}

@end
