/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
//
//  ViewController.m
//  nativepush
//
//  Created by worklightdev on 11/02/13.
//  Copyright (c) 2013 nativepush. All rights reserved.
//

#import "ViewController.h"
#import "AppDelegate.h"
#import "WLClient.h"
#import "MyConnectListener.h"
#import "ReadyToSubscribeListener.h"
#import "FormChallengeHandler.h"
#import "MySubscribeListener.h"
#import "MyUnsubscribeListener.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
	
	AppDelegate *appDelegate = [[UIApplication sharedApplication]delegate];
	appDelegate.appDelegateVC = self;
	
	[[WLPush sharedInstance]init];
	
	self.alias = @"iOSPushAlias";
	self.adapterName = @"PushAdapter";
	self.eventSourceName = @"PushEventSource";
	self.securityRealm = @"PushAppRealm";
	self.username = @"worklight";
	self.password = @"password";
	
	self.result.text = [NSString stringWithFormat:@"Alias             :: %@\nAdapter Name      :: %@\nEvent Source Name :: %@\nSecurity Realm    :: %@\n------------------------------------\nUser name :: %@\nPassword  :: %@", self.alias, self.adapterName, self.eventSourceName, self.securityRealm,self.username, self.password];
	[[WLPush sharedInstance]init];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

- (void)updateMessage:(NSString *)data{
	self.result.text = [NSString stringWithFormat:@"%@ \n%@", self.result.text, data];
}

- (IBAction)connect:(id)sender {
	self.result.text = @"Connecting to server and initializing push notification ... ";
	MyConnectionListener *connectListener = [[MyConnectionListener alloc] initWithController:self];
	
	ReadyToSubscribeListener *readyToSubscribeListener = [[ReadyToSubscribeListener alloc] initWithController:self];
	readyToSubscribeListener.alias = self.alias;
	readyToSubscribeListener.adapterName = self.adapterName;
	readyToSubscribeListener.eventSourceName = self.eventSourceName;
	
	[self updateMessage:[NSString stringWithFormat:@"ReadyToSubscibeListener Params :: %@ %@ %@", readyToSubscribeListener.alias, readyToSubscribeListener.adapterName, readyToSubscribeListener.eventSourceName]];
	
	[[WLPush sharedInstance] setOnReadyToSubscribeListener:readyToSubscribeListener];
	
	[[WLPush sharedInstance] setTokenFromClient:self.myToken];
	
    [[WLClient sharedInstance] wlConnectWithDelegate:connectListener];

	FormChallengeHandler *challengeHandler = [[FormChallengeHandler alloc] initWithController:self];
	challengeHandler.username = self.username;
	challengeHandler.password = self.password;
	
	[[WLClient sharedInstance] registerChallengeHandler:[challengeHandler initWithRealm:self.securityRealm]];
}

- (IBAction)isPushSupported:(id)sender {
	[[WLPush sharedInstance] isPushSupported]?(self.result.text = @"YES"):(self.result.text = @"NO");
}

- (IBAction)isSubscribed:(id)sender {
	[[WLPush sharedInstance] isSubscribed:self.alias]?(self.result.text = [NSString stringWithFormat:@"Subscribed for alias :: %@", self.alias]):(self.result.text = [NSString stringWithFormat:@"Not subscribed for alias :: %@", self.alias ]);
}

- (IBAction)subscribe:(id)sender {
	self.result.text=@"Trying to subscribe ...";
	MySubscribeListener *mySubscribeListener = [[MySubscribeListener alloc] initWithController:self];
	[[WLPush sharedInstance]subscribe:self.alias :nil :mySubscribeListener];
}

- (IBAction)unsubscribe:(id)sender {
	self.result.text = @"Trying to unsubscribe ... ";
	MyUnsubscribeListener *myUnsubscribelistener = [[MyUnsubscribeListener alloc]initWithController:self];
	[[WLPush sharedInstance]unsubscribe:self.alias :myUnsubscribelistener];
}

- (void)dealloc {
	[_result release];
	[_console release];
	[_button_push release];
	[_button_subscribe release];
	[_button_subscribe release];
	[_button_unsubscribe release];
	[_button_isSubscribe release];
	[_button_subscribe release];
    [super dealloc];
}
@end
